// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/DirectEchos.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHOS__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHOS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/direct_echos__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'direct_echos'
#include "off_highway_uss_msgs/msg/detail/direct_echo__traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const DirectEchos & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: direct_echos
  {
    if (msg.direct_echos.size() == 0) {
      out << "direct_echos: []";
    } else {
      out << "direct_echos: [";
      size_t pending_items = msg.direct_echos.size();
      for (auto item : msg.direct_echos) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const DirectEchos & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: direct_echos
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.direct_echos.size() == 0) {
      out << "direct_echos: []\n";
    } else {
      out << "direct_echos:\n";
      for (auto item : msg.direct_echos) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const DirectEchos & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::DirectEchos & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::DirectEchos & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::DirectEchos>()
{
  return "off_highway_uss_msgs::msg::DirectEchos";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::DirectEchos>()
{
  return "off_highway_uss_msgs/msg/DirectEchos";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::DirectEchos>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::DirectEchos>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<off_highway_uss_msgs::msg::DirectEchos>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__DIRECT_ECHOS__TRAITS_HPP_
