// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from off_highway_uss_msgs:msg/Information.idl
// generated code does not contain a copyright notice

#ifndef OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_
#define OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "off_highway_uss_msgs/msg/detail/information__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace off_highway_uss_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const Information & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: number_sensors
  {
    out << "number_sensors: ";
    rosidl_generator_traits::value_to_yaml(msg.number_sensors, out);
    out << ", ";
  }

  // member: sending_pattern
  {
    out << "sending_pattern: ";
    rosidl_generator_traits::value_to_yaml(msg.sending_pattern, out);
    out << ", ";
  }

  // member: operating_mode
  {
    out << "operating_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.operating_mode, out);
    out << ", ";
  }

  // member: outside_temperature
  {
    out << "outside_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.outside_temperature, out);
    out << ", ";
  }

  // member: sensor_blindness
  {
    out << "sensor_blindness: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_blindness, out);
    out << ", ";
  }

  // member: sensitivity
  {
    out << "sensitivity: ";
    rosidl_generator_traits::value_to_yaml(msg.sensitivity, out);
    out << ", ";
  }

  // member: sensor_faulted
  {
    out << "sensor_faulted: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_faulted, out);
    out << ", ";
  }

  // member: failure_status
  {
    out << "failure_status: ";
    rosidl_generator_traits::value_to_yaml(msg.failure_status, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const Information & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: number_sensors
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "number_sensors: ";
    rosidl_generator_traits::value_to_yaml(msg.number_sensors, out);
    out << "\n";
  }

  // member: sending_pattern
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sending_pattern: ";
    rosidl_generator_traits::value_to_yaml(msg.sending_pattern, out);
    out << "\n";
  }

  // member: operating_mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "operating_mode: ";
    rosidl_generator_traits::value_to_yaml(msg.operating_mode, out);
    out << "\n";
  }

  // member: outside_temperature
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "outside_temperature: ";
    rosidl_generator_traits::value_to_yaml(msg.outside_temperature, out);
    out << "\n";
  }

  // member: sensor_blindness
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_blindness: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_blindness, out);
    out << "\n";
  }

  // member: sensitivity
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensitivity: ";
    rosidl_generator_traits::value_to_yaml(msg.sensitivity, out);
    out << "\n";
  }

  // member: sensor_faulted
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "sensor_faulted: ";
    rosidl_generator_traits::value_to_yaml(msg.sensor_faulted, out);
    out << "\n";
  }

  // member: failure_status
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "failure_status: ";
    rosidl_generator_traits::value_to_yaml(msg.failure_status, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const Information & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace off_highway_uss_msgs

namespace rosidl_generator_traits
{

[[deprecated("use off_highway_uss_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const off_highway_uss_msgs::msg::Information & msg,
  std::ostream & out, size_t indentation = 0)
{
  off_highway_uss_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use off_highway_uss_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const off_highway_uss_msgs::msg::Information & msg)
{
  return off_highway_uss_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<off_highway_uss_msgs::msg::Information>()
{
  return "off_highway_uss_msgs::msg::Information";
}

template<>
inline const char * name<off_highway_uss_msgs::msg::Information>()
{
  return "off_highway_uss_msgs/msg/Information";
}

template<>
struct has_fixed_size<off_highway_uss_msgs::msg::Information>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<off_highway_uss_msgs::msg::Information>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<off_highway_uss_msgs::msg::Information>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // OFF_HIGHWAY_USS_MSGS__MSG__DETAIL__INFORMATION__TRAITS_HPP_
